﻿$(document).ready(function () {
    $("body").on("change", "#Conditions .condition-for-view .column-type:not(.select2-container)", function () {
        ruleFieldChanged($(this).closest(".condition-for-view"));
    });        
        
    $("body").on("click", ".btn-new-email-rule", function () {
        addNewFiltr();
    });

    $("body").on("click", "#Conditions .add-button", function () {
        addNewFiltr();
    });

    $("body").on("click", "#Conditions .delete-button", function () {
        deleteCondition($(this));
        if ($("#Conditions .condition-for-view").length == 0) {
            $(".btn-new-email-rule").show();
        }
    });

    $("#ActionForward").change(function () {
        $("#ForwardEmails").prop("disabled", !$(this).is(":checked"));
    });
    $("#ActionForward").trigger("change");

    $("#ActionReply").change(function () {
        if ($(this).is(":checked")) {
            $("#ActionReplyDiv").show();
        }
        else {
            $("#ActionReplyDiv").hide();
        }
    });

    $("#NewEmailRulesForm").submit(function (event) {
        $("#ReplySubjectValidError").hide();
        var result = true;
        if ($("#ActionReply").is(":checked") && $("#OwnSubject").is(":checked") && $("#replySubject").val() == "") {
            result = false;
            $("#ReplySubjectValidError").show();
        }
        var resultCondition = findSubcondition($("#Conditions").children(".condition-for-view"));
        return result && resultCondition;
    });

    $("#OwnSubject").change(function () {
        setSubjectVisibility();
    });

    $('.select2-emails').select2({
        placeholder: Localization_EmailRules_ForwardEmails,
        minimumInputLength: 0,
        allowClear: false,
        multiple: true,
        tags: true,
        width: '100%',
        tokenSeparators: [',', ';', ' '],
        createTag: function (tag) {
            if (isValidEmailAddress(tag.term)) { //kontrola validni email adresy
                return {
                    id: tag.term,
                    text: tag.term
                };
            }
            else return null;
        }
    });
    initDragAndDrop();
});

function setSubjectVisibility() {
    if ($("#OwnSubject").is(":checked")) {
        $("#replySubject").show();
    }
    else {
        $("#replySubject").hide();
        $("#ReplySubjectValidError").hide();
        $("#replySubject").val("");
    }
}

function deleteCondition($element) {
    $element.closest(".condition-for-view").remove();
    refreshRelationships();
}

function findSubcondition(conditions, name) {
    if (name == null) {
        name = "ConditionsModel";
    }
    else {
        name += ".Children";
    }
    var arrayResult = new Array();
    var result = true;
    for (var i = 0; i < conditions.length; i++) {
        var values = $(conditions[i]).find("> .value, > span > .value");
        for (var j = 0; j < values.length; j++) {
            var $valueElement = $(values[j]);
            var value = $valueElement.val();
            var resultValue = false;
            if ($valueElement.hasClass("spinner")) {
                resultValue = $.isNumeric(value);
            }
            if ($valueElement.hasClass("text")) {
                resultValue = value != null && value != "";
            }
        }
        if (resultValue == false) {
            result = resultValue;
            $(conditions[i]).find("> .valid-error").show(); //zobrazím chybu
        }
        else {
            $(conditions[i]).find("> .valid-error").hide(); //pokud byla zobrazena a už je to ok schovám ji
        }
        $(conditions[i]).find("> .condition-selects > select.relationship").attr("name", name + "[" + i + "].AndOrOr");
        $(conditions[i]).find("> .condition-selects > select.column-type").attr("name", name + "[" + i + "].ConditionField");
        
        $(conditions[i]).find("> .condition-selects > .column-operators").attr("name", name + "[" + i + "].Operator");
        $(conditions[i]).find("> .value, > span > .value").attr("name", name + "[" + i + "].Values[0]");
        if (result == false) {
            findSubcondition($(conditions[i]).children(".sub-children").children(".condition-for-view"), name + "[" + i + "]");
            result = false;
        }
        else {
            if ($(conditions[i]).children(".sub-children").children(".condition-for-view").length == 0) {
                result = true;
            }
            else {
                result = findSubcondition($(conditions[i]).children(".sub-children").children(".condition-for-view"), name + "[" + i + "]");
            }
        }
    }
    return result;
}

function ruleFieldChanged($rootElement) {
    var options = "";
    $element = $rootElement.find("> .condition-selects");
    var ruleString = $element.find("> .column-type").val();
    var id = -1;
    if (ruleString.indexOf(":") != -1) {
        id = ruleString.substr(0, ruleString.indexOf(":"));
    }
    else {
        id = ruleString;
    }
    var ruleId = id;

    if (ruleId == -1) {
        $element.find("> .column-operators").hide();

        if ($element.find("> .column-operators").data('select2')) {
            $element.find("> .column-operators").select2('destroy');
        }

        $rootElement.find("> .value, > span > .value").remove();
    }
    else {
        $.ajax({
            url: RQ_URL + "/Admin/EmailRules/GetRuleOperatorValues?RuleId=" + ruleId,
            context: document.body,
            async: false
        }).done(function (data) {
            $element.find("> .column-operators > option").remove();
            $(data).each(function () {
                options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
            });
            $element.find("> .column-operators").html(options);
            $element.find("> .column-operators").show();

            $element.find("> .column-operators").select2({ dropdownAutoWidth: true, minimumResultsForSearch: Infinity });
        });
        options = "";

        $.ajax({
            url: RQ_URL + "/Admin/EmailRules/GetRuleEnumeratorOrDataType?RuleId=" + ruleId,
            context: document.body,
            async: false
        }).done(function (data) {
            if ($rootElement.find("> .value").data('select2')) {
                $rootElement.find("> .value").select2('destroy');
            }

            $rootElement.find("> .value, > span > .value").remove();
            var operator_ddl = $element;
            setDataToRule(operator_ddl, data, null, null);
        })
        .fail(function (error) {
            alert(error.responseText);
        });
    }
}

function setDataToRule(operator_ddl, data, i, index) {
    if (data.value == undefined) {
        data.value = "";
    }
    if (data.Rules != undefined) {
        if (data.Rules[i].FieldType.Type == "spinner") {
            spinnerWithValue(operator_ddl, index, data.Rules[i].Values[0]);
        }
        else if (data.Rules[i].FieldType.Type == "textbox") {
            textboxWithValue(operator_ddl, index, data.Rules[i].Values[0]);
        }
    }
    else if ($.isArray(data)) {
        if (data[i].FieldType.Type == "spinner") {
            spinnerWithValue(operator_ddl, index, data[i].Values[0]);
        }
        else if (data[i].FieldType.Type == "textbox") {
            textboxWithValue(operator_ddl, index, data[i].Values[0]);
        }
    }
    else {
        if (data.Type == "spinner") {
            operator_ddl.after('<input type="text" value="1" class="spinner value" />');
            initSpinners();
        }
        else if (data.Type == "textbox") {
            operator_ddl.after('<input type="text" class="left text value" />');
            initSpinners();
        }
    }
}

function spinnerWithValue(operator_ddl, index, value) {
    var spinner = $('<input type="text" value="1" class="spinner value" />');
    operator_ddl.after(spinner);
    $(spinner).val(value);
    initSpinners();
}

function textboxWithValue(operator_ddl, index, value) {
    var textbox = $('<input type="text" class="left text value" />');
    operator_ddl.after(textbox);
    $(textbox).val(value);
    initSpinners();
}
var revert = false;

function addNewFiltr() {
    $(".btn-new-email-rule").hide();
    $("#Conditions").append($("#NewRowForCondition").html());

    $.ajax({
        url: RQ_URL + "/Admin/EmailRules/GetRuleFieldValuesForSelect2",
        context: document.body,
        async: false
    }).done(function (data) {
        var options = createOptionsForColumnType(data);
        $("#Conditions").find(".column-type").last().append(options);
        $("#Conditions").find(".column-type").last().select2({ dropdownAutoWidth: true }); //reinit sirky (kvuli options)
        $("#Conditions").find(".column-operators").last().hide();
        $("#Conditions").find(".column-type").last().val("-1").trigger("change");
    })
    .fail(function (error) {
        alert(error.responseText);
    });
    refreshRelationships();

    initDragAndDrop();
}

function initDragAndDrop() {
    $(".condition-for-view").draggable({
        handle: ".handle",
        helper: "original",
        appendTo: "body",
        revert: "invalid",
        cursor: "move",
        zIndex: 10000,
        scroll: true,
        start: function (event, ui) {
            elementDepth = 0;
        },
        stop: function (event, ui) {
            if (!revert) {

            }
        }

    });

    $(".condition-for-view").droppable({
        tolerance: "pointer",
        out: function (event, ui) {
            revert = true;
        },
        over: function (event, ui) {
            revert = false;
        },
        drop: function (event, ui) {
            revert = false;
            actualElementDepth = $(event.target).parents("*").not("body,html").length;
            var dataid = $(event.target).attr("data-id");
            if (actualElementDepth > elementDepth) {
                var top = ui.offset.top - $(this).offset().top;
                var height = 5;
                if (top >= height) {
                    $(event.target).find(".sub-children:first").append($(ui.draggable));
                }
                else {
                    $(event.target).before($(ui.draggable));
                }
                $(".condition-for-view").css("left", "0px");
                $(".condition-for-view").css("top", "0px");
            }
            refreshRelationships();
            elementDepth = actualElementDepth;
        }
    });
}

function refreshRelationships() {
    var realationships = $("#Conditions").find(".condition-selects > .relationship");

    $(realationships).each(function (index, value) {
        if ($(value).data('select2')) {
            $(value).select2('destroy');
        }
        if (index == 0) {
            $(value).hide();
        }
        else {
            $(value).css("display", "inline-block");
            $(value).select2({ dropdownAutoWidth: true, minimumResultsForSearch: Infinity });
        }
    });
}

function createOptionsForColumnType(fields) {
    var currentGroupKey;
    var groupOpened = false;
    var options = "<option value='-1'>" + Localization_SelectInSelect + "</option>";

    for (var j = 0; j < fields.length; j++) {
        if (currentGroupKey != fields[j].GroupKey) {
            currentGroupKey = fields[j].GroupKey;

            if (groupOpened) {
                options += "</optgroup>";
            }

            options += '<optgroup label="' + fields[j].GroupName + '" value="' + fields[j].GroupKey + '">';
            groupOpened = true;
        }
        var htmlattributes = "";
        $(fields[j].HtmlAttributes).each(function () {
            htmlattributes += " " + this.Name + "='" + this.Value + "'";
        });

        options += "<option value='" + fields[j].Value + "'" + htmlattributes + ">" + fields[j].Text + "</option>";
    }
    if (groupOpened) {
        options += "</optgroup>";
    }
    return options;
}

function initSpinners() {
    $('.spinner').spinner({
        min: 1, max: 999, stop: function (e, ui) {
        }
    });
}
