﻿if (typeof (Storage) !== "undefined" && "Notification" in window) { // prohlizec podporuje localStorage a notifikace
    if (Notification.permission === "granted") { // notifikace jsou povolene
        firebase.initializeApp({
            apiKey: "AIzaSyBg9GoUvLLTHUEn-knqFeBUY850mfM7uXA",
            projectId: "supple-craft-88112",
            messagingSenderId: "528071331944"
        });

        const messaging = firebase.messaging();
        messaging.usePublicVapidKey("BHtgdGaxSnaC9pWFrtkpvK6gMn_xvmrvOOgNYuVvcu8CPsJnDdrK3gSHxnTnfCMLtPcppoE3KALkQU0mV3b27L0");

        messaging.onMessage(function (payload) {
            var notification = new Notification(payload.data.ticketref, {
                body: payload.data.body,
                icon: RQ_URL + "/favicon-96x96.png",
                badge: RQ_URL + "/app-badge-96x96.png",
                renotify: true,
                tag: payload.data.ticketref
            });

            notification.onclick = function (event) {
                notification.close();
                window.focus();
                console.log("FCM: focus from tab");

                var urlPathArray = urlUtils.getUrlPathArray();
                if (urlPathArray.length <= 1 || urlPathArray[urlPathArray.length - 1] !== payload.data.ticketref) { //pokud toto neni detail pozadavku, je treba se na nej presmerovat
                    var ticketUrl = RQ_URL + '/Tickets/Show/' + payload.data.ticketref;
                    if (payload.data.ticketusermessageid)
                        ticketUrl += "#" + payload.data.ticketusermessageid;

                    window.location.href = ticketUrl;
                }
            };
        });

        processFcmTokenRegistration = function () {
            if (!localStorage.registeredFcmToken) { // registrace tokenu na serveru probehne jen tehdy, pokud uz neni registrovany
                messaging.getToken().then(function (currentToken) {
                    if (currentToken) {
                        $.post(
                            RQ_URL + "/PushNotifications/RegisterWebClient",
                            { instanceIdToken: currentToken },
                            function (data) {
                                if (data === "OK") {
                                    localStorage.registeredFcmToken = currentToken;
                                }
                                else {
                                    console.error("Server failed while registering Instance Id token.");
                                }
                            },
                            "json"
                        );
                    } else {
                        console.error('No Instance ID token available. Request permission to generate one.');
                    }
                }).catch(function (err) {
                    console.error('An error occurred while retrieving token. ', err);
                });
            }
        };

        messaging.onTokenRefresh(function () { // prohlizec aktualizoval InstanceIdToken, je treba registrovat ho na serveru
            localStorage.removeItem("registeredFcmToken");
            processFcmTokenRegistration();
        });

        navigator.serviceWorker.register(RQ_URL + '/firebase-messaging-sw.js').then(function (registration) { // tato funkce se muze volat vicenasobnekrat, k registraci service workeru dojde jen jednou            
            messaging.useServiceWorker(registration);
            processFcmTokenRegistration();
        }, function (err) {
            console.error(err);
        });
    }
    else if (localStorage.registeredFcmToken) {
        localStorage.removeItem("registeredFcmToken"); // Pokud se zakazou notifikace, potom se pri jejich dalsim povoleni zmeni i InstanceIdToken (Chrome), soucasny token je proto treba oznacit jako neregistrovany.
    }
}