﻿$(document).ready(function () {
    // -------- track time            

    $("#dialog-track-time-record").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            id: "trackTimeRecordSaveButton",
            text: Localization_Save,
            click: function () {
                ValidateAndSubmitDialog("#dialog-track-time-record");
            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-track-time-record-for-stopwatch").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        create: function () { //stejna akce na krizek jako na tl. Storno
            $(this).closest('div.ui-dialog')
                .find('.ui-dialog-titlebar-close')
                .click(function (e) {
                    if ($("#dialog-track-time-record-for-stopwatch").data('action') == 'start') {
                        resetStopWatch();
                        $.connection.stopWatchHub.server.resetStopWatch();
                    }
                });
        },
        buttons: [{
            text: Localization_Save,
            click: function () {
                var tbFromDate = $('#dialog-track-time-record-for-stopwatch .js-tbTrackTimeFromDate');
                var tbFromTime = $('#dialog-track-time-record-for-stopwatch .js-tbTrackTimeFromTime');

                if (tbFromDate.length && tbFromTime.length) {
                    var fromDate = moment(tbFromDate.val(), "L");
                    var fromTime = moment(tbFromTime.val(), "LT");

                    if (tbFromDate.val().trim() != '' && tbFromTime.val().trim() && fromDate.isValid() && fromTime.isValid()) {
                        var from = moment({ year: fromDate.year(), month: fromDate.month(), day: fromDate.date(), hour: fromTime.hour(), minute: fromTime.minute() });

                        if (from.isAfter(moment(), 'minute')) { //korekce, aby nebyl from v budoucnosti
                            from = moment();
                            $(tbFromDate).val(from.format('l'));
                            $(tbFromTime).val(from.format('HH:mm'));
                        }

                        var stopWatchStartedAt = moment().subtract(stopWatchSeconds, 'seconds');

                        if (!from.isSame(stopWatchStartedAt, 'minute')) { //uzivatel zadal datum v minulosti -> navysime pocitadlo, nebo naopak ho pozdeji posunul z minulosti do "mensi" minulosti
                            var duration = moment.duration(moment().diff(from));
                            var seconds = Math.round(duration.asSeconds());
                            setStopWatchSeconds(seconds);
                            $.connection.stopWatchHub.server.setSeconds(seconds);
                        }
                    }
                }

                $("#dialog-track-time-record-for-stopwatch .js-track-time-record-form").submit();
                $(this).dialog("close"); //dialog zaviram hned, nemusim cekat na vysledek, nikdy by nemel byt chybovy, neni tam treba validace
            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");

                if ($(this).data('action') == 'start') {
                    resetStopWatch();
                    $.connection.stopWatchHub.server.resetStopWatch();
                }
            }
        }]
    });
}); //end document ready


function OnTrackTimeRecordAjaxSuccess(data, form) {
    var dialogDiv = $(form).closest(".js-dialog-track-time-record");
    if (data.result.Success) {

        if (dialogDiv.attr('id') == 'dialog-track-time-record') {
            if (data.fromDraft) { //finalni ulozeni noveho zaznamu z draftu
                resetStopWatch();
                $.connection.stopWatchHub.server.resetStopWatch();
            }

            dialogDiv.dialog('close'); //jen tento dialog 'dialog-track-time-record', dialog-track-time-record-for-stopwatch se zavira hned, ne az po postu

            if ($('#jqGridTrackTimeRecords').length) {
                $('#jqGridTrackTimeRecords').trigger("reloadGrid");
            }

            if ($('aside#ticket-track-time').length && typeof ticketId !== 'undefined' && data.ticketId == ticketId) { //jsem v detailu pozadavku
                window.location.reload();
            }

            ShowSuccess($('#hiddenMessageTrackTimeRecordSavedSuccessfully').val());
        }
        else if (dialogDiv.attr('id') == 'dialog-track-time-record-for-stopwatch') {
            setStopWatchTicketLink(data.ticketREF);
            $.connection.stopWatchHub.server.linkTicket(data.ticketREF);
        }
    }
    else {
        dialogDiv.html(data.html); //some form errors, redisplay form
    }
}


function ValidateTrackTimeRecordDurationInput(dialogId) {
    var input = $(dialogId + " .js-tbTrackTimeRecordDuration").val().replace(/ /g, '');
    var regex1 = new RegExp("^[0-9]+:[0-9]{1,2}$");
    var regex2 = new RegExp("^[0-9]+h[0-9]{1,2}m$");
    var regex3 = new RegExp("^[0-9]+m?$");
    var regex4 = new RegExp("^[0-9]+([,\.][0-9]+)?h$");
    return regex1.test(input) || regex2.test(input) || regex3.test(input) || regex4.test(input);
}

function ValidateTrackTimeFromUntilInput(dialogId) {

    var tbFromDate = $(dialogId + ' .js-tbTrackTimeFromDate');
    var tbFromTime = $(dialogId + ' .js-tbTrackTimeFromTime');
    var tbUntilDate = $(dialogId + ' .js-tbTrackTimeUntilDate');
    var tbUntilTime = $(dialogId + ' .js-tbTrackTimeUntilTime');

    var fromDate = moment(tbFromDate.val(), "L");
    var fromTime = moment(tbFromTime.val(), "LT");
    var untilDate = moment(tbUntilDate.val(), "L");
    var untilTime = moment(tbUntilTime.val(), "LT");

    if (tbFromDate.val().trim() != '' && tbFromTime.val().trim() != '' && tbUntilDate.val().trim() != '' && tbUntilTime.val().trim() != '' && fromDate.isValid() && fromTime.isValid() && untilDate.isValid() && untilTime.isValid()) {
        var from = moment({ year: fromDate.year(), month: fromDate.month(), day: fromDate.date(), hour: fromTime.hour(), minute: fromTime.minute() });
        var until = moment({ year: untilDate.year(), month: untilDate.month(), day: untilDate.date(), hour: untilTime.hour(), minute: untilTime.minute() });
        return from < until;
    }
    else
        return false;
}

function HasTrackTimeFromUntilValue(dialogId) {
    var tbFromDate = $(dialogId + ' .js-tbTrackTimeFromDate');
    var tbFromTime = $(dialogId + ' .js-tbTrackTimeFromTime');
    var tbUntilDate = $(dialogId + ' .js-tbTrackTimeUntilDate');
    var tbUntilTime = $(dialogId + ' .js-tbTrackTimeUntilTime');

    return tbFromDate.val().trim() != '' || tbFromTime.val().trim() != '' || tbUntilDate.val().trim() != '' || tbUntilTime.val().trim() != '';
}

function IsSameDay(dialogId) {
    var tbFromDate = $(dialogId + ' .js-tbTrackTimeFromDate');
    var tbUntilDate = $(dialogId + ' .js-tbTrackTimeUntilDate');
    var tbUntilTime = $(dialogId + ' .js-tbTrackTimeUntilTime');

    var fromDate = moment(tbFromDate.val(), "L");
    var untilDate = moment(tbUntilDate.val(), "L");
    var untilTime = moment(tbUntilTime.val(), "LT");
    if (tbFromDate.val().trim() != '' && tbUntilDate.val().trim() != '' && fromDate.isValid() && untilDate.isValid()) {
        var fromWithoutTime = moment({ year: fromDate.year(), month: fromDate.month(), day: fromDate.date(), hour: 0, minute: 0 });
        var until = moment({ year: untilDate.year(), month: untilDate.month(), day: untilDate.date(), hour: untilTime.hour(), minute: untilTime.minute() });
        var fromNextDayWithoutTime = moment({ year: fromDate.year(), month: fromDate.month(), day: fromDate.date(), hour: 0, minute: 0 }).add(1, 'd');

        return (fromWithoutTime.isSame(until, 'day') || fromNextDayWithoutTime.isSame(until));
    }
    else
        return false;
}

function ValidateAndSubmitDialog(dialogId) {
    var error = ValidateTrackTimeDialog(dialogId);
    if (!error) {
        if ($(dialogId + " .js-activity option:selected").data("type") == "General" || IsSameDay(dialogId)) {
            $(dialogId + " .js-split-timespan").val("False");
            $(dialogId + " .js-track-time-record-form").submit();
        } else {
            $(".js-split-timespan-dialog").dialog("open");
        }
    }
}

function ValidateTrackTimeDialog(dialogId) {
    $(dialogId + " .valid-error").hide();
    var error = false;
    if ($(dialogId + " .js-activity").val() == "") {
        $(dialogId + " .js-trackTimeRecordActivityIsRequired").show();
        error = true;
    } else {
        if ($(dialogId + " .js-activity option:selected").data("type") == "Time") {
            tryToFillEmptyTimeFields(dialogId);
            if (!HasTrackTimeFromUntilValue(dialogId)) {
                $(dialogId + " .js-trackTimeRecordFromUntilCorrectFormat").show();
                error = true;
            } else if (!ValidateTrackTimeFromUntilInput(dialogId)) {
                $(dialogId + " .js-trackTimeRecordEndDateMustBeGreaterThanStartDate").show();
                error = true;
            }

            if ($(dialogId + " .js-tbTrackTimeRecordDuration").val() == "") {
                $(dialogId + " .js-trackTimeRecordDurationRequired").show();
                error = true;
            }

            if ($(dialogId + " .js-trackTimeOperator").val() == "") {
                $(dialogId + " .js-trackTimeRecordOperatorIsRequired").show();
                error = true;
            }
        } else if ($(dialogId + " .js-activity option:selected").data("type") == "General") {
            if ($(dialogId + " .js-track-time-count").val() == "") {
                $(dialogId + " .js-trackTimeRecordCountRequired").show();
                error = true;
            }
            if ($(dialogId + " .js-dateofimplementation").val() == "") {
                $(dialogId + " .js-trackTimeRecordDateOfImplementationRequired").show();
                error = true;
            }
        }
    }
    return error;
}

function OpenAddTrackTimeRecordDialog(dialogId, buttonElementId, id, type, fromDraft) {
    $(dialogId).html("<div class='loading-32'></div>");
    $(buttonElementId).text(Localization_Create);
    $(dialogId).dialog('open');
    $(dialogId).load(RQ_URL + "/TrackTimeRecords/GetNewTrackTimeRecord?ticketId=" + id + "&type=" + type + "&fromDraft=" + fromDraft + "&dialogId=" + encodeURIComponent(dialogId), function () {
        $(dialogId).dialog('close');
        $(dialogId).dialog('open');
    });
}

function OpenEditTrackTimeRecordDialog(dialogId, buttonElementId, id, type, fromDraft) {
    $(dialogId).html("<div class='loading-32'></div>");
    $(buttonElementId).text(Localization_Save);
    $(dialogId).dialog('open');
    $(dialogId).load(RQ_URL + "/TrackTimeRecords/LoadTrackTimeRecord/" + id + "?type=" + type + "&fromDraft=" + fromDraft+ "&dialogId=" + dialogId, function () {
        $(dialogId).dialog('close');
        $(dialogId).dialog('open');
    });
}

function CreateCopyFromTrackTimeRecordDialog(dialogId, buttonElementId, id, type) {
    $(dialogId).html("<div class='loading-32'></div>");
    $(buttonElementId).text(Localization_Save);
    $(dialogId).dialog('open');
    $(dialogId).load(RQ_URL + "/TrackTimeRecords/CreateCopy?originalId=" + id + "&type=" + type + "&dialogId=" + dialogId, function () {
        $(dialogId).dialog('close');
        $(dialogId).dialog('open');
    });
}

function DeleteTrackTimeRecord(id) {
    $.post(RQ_URL + "/TrackTimeRecords/DeleteTrackTimeRecord",
        { id: id },
        function (data) {
        },
        "json"
    )
        .fail(function (error) { alert(error.responseText); })
        .always(function () {
            OnTrackTimeRecordDeleteAjaxComplete();
        });
}

function changePriceBoxes(element) {
    dialogId = getDialogId(element);
    if ($(dialogId + " .js-preparedPrices").is(":visible")) {
        $(dialogId + " .js-preparedPrices").hide();
        $(dialogId + " .js-myPrice").show();
        $(dialogId + " .js-my-price").val("True");
        $(dialogId + " .js-price").val($(dialogId + " .js-selected-price option:selected").data("price"));
        $(dialogId + " .js-selected-currency").val($(dialogId + " .js-selected-price option:selected").data("currency"));
        $(dialogId + " .js-selected-currency").trigger("change");
        $(dialogId + " .js-change-price-boxes").addClass("active");
        $(dialogId + " .js-change-price-boxes").html('<i class="fa fa-undo fa-lg fa-fw"></i>');
    } else {
        $(dialogId + " .js-preparedPrices").show();
        $(dialogId + " .js-myPrice").hide();
        $(dialogId + " .js-my-price").val("False");
        $(dialogId + " .js-change-price-boxes").removeClass("active");
        $(dialogId + " .js-change-price-boxes").html('<i class="fa fa-pencil-square-o fa-lg fa-fw"></i>');
    }
    recountTotalPrice(dialogId);
}

function reloadPrices(dialogId) {
    $(dialogId + " .js-prices").html("");
    if ($(dialogId + " .js-activity").val() != "") {
        $(dialogId + " .js-prices").html("<div class='loading-32'></div>");
        $(dialogId + " .js-prices").load(RQ_URL + "/TrackTimeRecords/ReloadPrices?customerId=" + $(dialogId + " .js-customer-id").val() + "&activityId=" + $(dialogId + " .js-activity").val(), function () {
            Select2Combos();
            recountTotalPrice(dialogId);
        });
    }
}

function reloadActivityType(dialogId) {
    $(dialogId + " .js-activity-type").html("");
    if ($(dialogId + " .js-activity").val() != "") {
        $(dialogId + " .js-activity-type").html("<div class='loading-32'></div>");
        $(dialogId + " .js-activity-type").load(RQ_URL + "/TrackTimeRecords/ReloadActivityType/" + $(dialogId + " .js-activity").val() + "?trackTimeDialogType=" + $(dialogId + ' .js-track-time-dialog-type').val() + "&fromDraft=" + $(dialogId + " .js-from-draft").val() + "&trackTimeRecordId=" + $(dialogId + " #Id").val(), function () {
            Select2Combos();
            recountTotalPrice(dialogId);
            if ($(".js-track-time-count").length > 0) {
                $(".js-track-time-count").select();
            }
            if ($(".js-tbTrackTimeRecordDuration").length > 0) {
                $(".js-tbTrackTimeRecordDuration").select();
            }
        });
    }
}

function getDefaultInvoiceState(dialogId) {
    if ($(dialogId + " .js-activity").val() != "") {
        $.ajax({
            url: RQ_URL + '/TrackTimeRecords/GetDefaultInvoiceState',
            data: {
                id: $(dialogId + " .js-activity").val(),
            },
            type: "POST",
            error: function (error) { alert(error.responseText); },
            success: function (result) {
                $(dialogId + " .js-selected-invoice").val(result.DefaultInvoiceState).trigger("change");
            }
        });
    }
}

function setDurationTime(value) {
    $(".js-tbTrackTimeRecordDuration").val(value).trigger("change");
}

function changeCurrencyLabelOnPrice(element) {
    dialogId = getDialogId(element);
    $(".js-currency-addon").text($(dialogId + " .js-selected-currency").val());
    recountTotalPrice(dialogId);
}

function setDuration(dialogId) {
    if ($(dialogId + ' .js-tbTrackTimeFromDate').length && $(dialogId + ' .js-tbTrackTimeFromTime').length && $(dialogId + ' .js-tbTrackTimeUntilDate').length && $(dialogId + ' .js-tbTrackTimeUntilTime').length &&
        $(dialogId + ' .js-tbTrackTimeFromDate').val() != "" && $(dialogId + ' .js-tbTrackTimeFromTime').val() != "" && $(dialogId + ' .js-tbTrackTimeUntilDate').val() != "" && $(dialogId + ' .js-tbTrackTimeUntilTime').val() != "") {
        var startDate = moment($(dialogId + ' .js-tbTrackTimeFromDate').datepicker('getDate'));
        startDate.hours($(dialogId + ' .js-tbTrackTimeFromTime').timepicker('getHour'));
        startDate.minute($(dialogId + ' .js-tbTrackTimeFromTime').timepicker('getMinute'));

        var endDate = moment($(dialogId + ' .js-tbTrackTimeUntilDate').datepicker('getDate'));
        endDate.hours($(dialogId + ' .js-tbTrackTimeUntilTime').timepicker('getHour'));
        endDate.minute($(dialogId + ' .js-tbTrackTimeUntilTime').timepicker('getMinute'));

        var c = endDate.diff(startDate);
        var c2 = moment.duration(endDate.diff(startDate)).asMinutes();

        setDurationFromMinutes(dialogId, moment.duration(endDate.diff(startDate)).asMinutes());

        recountTotalPrice(dialogId);
    }
}

function setDateEnd(dialogId) {
    if ($(dialogId + ' .js-tbTrackTimeFromDate').length && $(dialogId + ' .js-tbTrackTimeFromTime').length && $(dialogId + ' .js-tbTrackTimeRecordDuration').length &&
        $(dialogId + ' .js-tbTrackTimeFromDate').val() != "" && $(dialogId + ' .js-tbTrackTimeFromTime').val() != "" && $(dialogId + ' .js-tbTrackTimeRecordDuration').val() != "") {
        var endDate = moment($(dialogId + ' .js-tbTrackTimeFromDate').datepicker('getDate'));
        endDate.hours($(dialogId + ' .js-tbTrackTimeFromTime').timepicker('getHour'));
        endDate.minute($(dialogId + ' .js-tbTrackTimeFromTime').timepicker('getMinute'));

        if (durationIsValid($(dialogId + ' .js-tbTrackTimeRecordDuration').val())) {
            var minutes = parseDurationToMinutes($(dialogId + ' .js-tbTrackTimeRecordDuration').val());

            endDate.add(minutes, "minutes");
            setDurationFromMinutes(dialogId, minutes);
        } else {
            var durationSplited = $(dialogId + ' .js-tbTrackTimeRecordDuration').val().split(':');

            endDate.add(durationSplited[0], "hours");
            endDate.add(durationSplited[1], "minutes");
        }

        $(dialogId + ' .js-tbTrackTimeUntilDate').val(endDate.format('l'));
        $(dialogId + ' .js-tbTrackTimeUntilTime').val(endDate.format('HH:mm'));
    }
}

function setDateStart(dialogId) {
    if ($(dialogId + ' .js-tbTrackTimeUntilDate').length && $(dialogId + ' .js-tbTrackTimeUntilTime').length && $(dialogId + ' .js-tbTrackTimeRecordDuration').length &&
        $(dialogId + ' .js-tbTrackTimeUntilDate').val() != "" && $(dialogId + ' .js-tbTrackTimeUntilTime').val() != "" && $(dialogId + ' .js-tbTrackTimeRecordDuration').val() != "") {
        var endDate = moment($(dialogId + ' .js-tbTrackTimeUntilDate').datepicker('getDate'));
        endDate.hours($(dialogId + ' .js-tbTrackTimeUntilTime').timepicker('getHour'));
        endDate.minute($(dialogId + ' .js-tbTrackTimeUntilTime').timepicker('getMinute'));

        if (durationIsValid($(dialogId + ' .js-tbTrackTimeRecordDuration').val())) {
            var minutes = parseDurationToMinutes($(dialogId + ' .js-tbTrackTimeRecordDuration').val());

            endDate.add(-minutes, "minutes");
            setDurationFromMinutes(dialogId, minutes);
        } else {
            if ($(dialogId + ' .js-tbTrackTimeRecordDuration').val().indexOf(':') != -1) {
                var durationSplited = $(dialogId + ' .js-tbTrackTimeRecordDuration').val().split(':');

                endDate.add(-durationSplited[0], "hours");
                endDate.add(-durationSplited[1], "minutes");
            } else {
                endDate.add(-$(dialogId + ' .js-tbTrackTimeRecordDuration').val().split(':'), "minutes");
            }
        }

        $(dialogId + ' .js-tbTrackTimeFromDate').val(endDate.format('l'));
        $(dialogId + ' .js-tbTrackTimeFromTime').val(endDate.format('HH:mm'));

        recountTotalPrice(dialogId);
    }
}

function setDurationFromMinutes(dialogId, durationInMinutes) {
    var quotient = Math.floor(durationInMinutes / 60);
    var remainder = Math.abs(durationInMinutes % 60);

    if (quotient < 99 && quotient >= 0) // pokud zadám minulost tak může být mínus
        quotient = ("0" + quotient).slice(-2);
    if (remainder < 99)
        remainder = ("0" + remainder).slice(-2);

    $(dialogId + ' .js-tbTrackTimeRecordDuration').val(quotient + ":" + remainder);
}

function tryToFillEmptyTimeFields(dialogId) {
    if ($(dialogId + " .js-tbTrackTimeRecordDuration").val() != "" && $(dialogId + ' .js-tbTrackTimeUntilDate').val() != "" && $(dialogId + ' .js-dialogId').val() != "") {
        setDateStart(dialogId);
    } else if ($(dialogId + " .js-tbTrackTimeRecordDuration").val() != "" && $(dialogId + ' .js-tbTrackTimeFromDate').val() != "" && $(dialogId + ' .js-tbTrackTimeFromTime').val() != "") {
        setDateEnd(dialogId);
    } else if ($(dialogId + ' .js-tbTrackTimeFromDate').val() != "" && $(dialogId + ' .js-tbTrackTimeFromTime').val() != "" && $(dialogId + ' .js-tbTrackTimeUntilDate').val() != "" && $(dialogId + ' .js-tbTrackTimeUntilTime').val() != "") {
        setDuration(dialogId);
    }
}

function getDialogId(element) {
    return $(element).closest("form").find(".js-dialog-id").val();
}

function recountTotalPrice(dialogId) {
    // je tam ajax select může nastat že to neexistuje
    if ($(dialogId + " .js-my-price").length > 0 && ($(dialogId + ' .js-tbTrackTimeRecordDuration').length > 0 || $(dialogId + " .js-track-time-count").length)) {
        if ($(dialogId + " .js-activity option:selected").data("type") == "Time") {
            if ($(dialogId + ' .js-tbTrackTimeRecordDuration').val() != "") {
                var seconds = 0;
                if ($(dialogId + ' .js-tbTrackTimeRecordDuration').val().indexOf(':') != -1) {
                    var durationSplited = $(dialogId + ' .js-tbTrackTimeRecordDuration').val().split(':');
                    //převod na sekundy kvůli dalším výpočtum
                    seconds = parseInt(durationSplited[0]) * 60 * 60;
                    seconds += parseInt(durationSplited[1]) * 60;
                } else {
                    seconds = parseInt($(dialogId + ' .js-tbTrackTimeRecordDuration').val()) * 60;
                }
                var count = 0;
                if ($(dialogId + " .js-activity-unit").val() == "Second") {
                    count = seconds;
                } else if ($(dialogId + " .js-activity-unit").val() == "Minute") {
                    count = seconds / 60;
                } else if ($(dialogId + " .js-activity-unit").val() == "Hour") {
                    count = seconds / 60 / 60;
                } else if ($(dialogId + " .js-activity-unit").val() == "Day") {
                    count = seconds / 60 / 60 / 24;
                } else {
                    alert("Not defined");
                }
                $(".js-total-price").text((count * getPrice(dialogId)).toLocaleString(language, { minimumFractionDigits: 2 }) + " " + getCurrency(dialogId));
            } else {
                $(".js-total-price").text("");
            }
        } else {
            if ($(dialogId + " .js-track-time-count").val() != "") {
                $(".js-total-price").text(($(dialogId + " .js-track-time-count").val() * getPrice(dialogId)).toLocaleString(language, { minimumFractionDigits: 2 }) + " " + getCurrency(dialogId));
            } else {
                $(".js-total-price").text("");
            }
        }
    }
}

function getPrice(dialogId) {
    if ($(dialogId + " .js-my-price").val() == "True") {
        return parseFloat($(dialogId + " .js-price").val().replace(',', '.').replace(' ', ''));
    } else {
        return parseFloat($(dialogId + " .js-selected-price option:selected").data("price").toString().replace(',', '.').replace(' ', ''));
    }
}

function getCurrency(dialogId) {
    if ($(dialogId + " .js-my-price").val() == "True") {
        return $(dialogId + " .js-selected-currency").val();
    } else {
        return $(dialogId + " .js-selected-price option:selected").data("currency")
    }
}